unit selcntry;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, HotImage, Grids, DBGrids, Db, StdCtrls, DBCtrls, DBTables;

type
  Tfrmselcntry = class(TForm)
    HotImage1: THotImage;
    dsRegions: TDataSource;
    DBGridRegions: TDBGrid;
    Countries: TTable;
    GroupBox1: TGroupBox;
    Button1: TButton;
    DBText1: TDBText;
    Label2: TLabel;
    DBText2: TDBText;
    Label3: TLabel;
    DBText3: TDBText;
    CountriesName: TStringField;
    CountriesCapital: TStringField;
    CountriesContinent: TStringField;
    CountriesArea: TFloatField;
    CountriesPopulation: TFloatField;
    DBText4: TDBText;
    Label4: TLabel;
    procedure HotImage1Paint(Sender: TObject);
    procedure HotImage1Click(Sender: TObject);
    procedure dsRegionsDataChange(Sender: TObject; Field: TField);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FSelectedSpot:TSpot;
    FRegion:integer;
    FBrush:TBitmap;
   procedure DrawSpot;
   procedure InvalidateRegion;
  protected
   procedure SetSelectedSpot(ASpot:TSpot);
  public
    { Public declarations }
  end;

var
  frmselcntry: Tfrmselcntry;

implementation

{$R *.DFM}
{$R addons.res}

procedure Tfrmselcntry.SetSelectedSpot(ASpot:TSpot);
begin
 if FSelectedSpot<>ASpot then
 begin
   DrawSpot;
   InvalidateRegion;
   FSelectedSpot:=ASpot;
   if assigned(ASpot)then
   begin
    FRegion:=HotImage1.CreateRgnByID(ASpot.SpotID);
    DrawSpot;
   end;
 end;
end;

procedure Tfrmselcntry.InvalidateRegion;
begin
 if FRegion<>0 then
 begin
  DeleteObject(FRegion);
  FRegion:=0;
 end;
end;

procedure Tfrmselcntry.DrawSpot;
begin
if FRegion=0 then exit;
 With HotImage1.Canvas do
 begin

//  Brush.Color:=clWhite;
  Brush.Bitmap:=FBrush;

 // Pen.Color:=clBlack;
//  Pen.Width:=6;
 Pen.Mode:=pmNotXor;
  FillRgn(Handle,FRegion,Brush.Handle);
 end;

end;


procedure Tfrmselcntry.HotImage1Paint(Sender: TObject);
begin
  DrawSpot;
end;

procedure Tfrmselcntry.HotImage1Click(Sender: TObject);
var DS:TDataSet;
begin
 if HotImage1.SpotIndex<0 then exit;
 DS:=dsRegions.DataSet;
 If assigned(DS) and ds.Active then
 begin
  With HotImage1 do
   DS.Locate('name',HotSpots[SpotIndex].HintText,[]);
 end;
end;

procedure Tfrmselcntry.dsRegionsDataChange(Sender: TObject;
  Field: TField);
var
    TempStr:string;
    I:integer;
    Spot:TSpot;
begin
 TempStr:=CountriesName.Value;
 Spot:=nil;
 With HotImage1 do
  for i:=0 to HotSpots.Count-1 do
  begin
   if HotSpots[i].HintText=TempStr then
   begin
     Spot:=HotSpots[i];
     break;
   end;
  end;
 SetSelectedSpot(Spot);
end;

procedure Tfrmselcntry.FormDestroy(Sender: TObject);
begin
 InvalidateRegion;
 FBrush.Free;
end;

procedure Tfrmselcntry.FormCreate(Sender: TObject);
begin
 FBrush:= TBitMap.Create;
  FBrush.LoadFromResourceName(hInstance,'GRAYBRUSH');
end;

end.
